# OpenGloves Driver [![Steam Badge]][Steam] [![Discord Badge]][Discord]

A general purpose **SteamVR** driver with an **[Open Interface]** <br>
for anyone to connect their **DIY** **VR** *( Glove )* hardware.

---

**⸢ [Installation] ⸥ ⸢ [Limitations] ⸥ ⸢ [Compatibility] ⸥**

---

## Features

- **Haptic Force Feedback**

- **Full Finger Tracking** <br>
    *‹ Beta › Splay Support* <br>
    *‹ Beta › Individual Joint Support*

- **Tracker / Controller Positioning** <br>
    *Automatic relative calibration* <br>
    *Controller ⟷ Glove*

- **Button / Joystick Inputs** <br>
    *➜ Trigger | A | B* <br>
    *➜ Joystick | X | Y | Click*

- **Multiple Communication Protocols** <br>
    *- Bluetooth Serial* <br>
    *- Named Pipes* <br>
    *- Serial USB*

<br>

### Steam UI

The **[Steam]** version of **OpenGloves** also comes <br>
with a **[UI]** for configuring driver related features.

##### UI Supported Features
- Force Feedback Testing
- Editable Driver Settings
- Automatic Calibration <br>
    *Controller ⟷ Glove*

---

## Contributing

**Pull requests are very welcome.**

*For major changes, please open an* <br>
***[Issue]*** *or contact us first to discuss* <br>
*what you would like to change.*

---

## Credits

| Author | Discord |
|:------:|:-------:|
| **[Danwillm]** | `danwillm#8254` |
| **[Lucas VRTech]** | `LucidVR#0001` |


<!----------------------------------------------------------------------------->

[Steam Badge]: https://img.shields.io/badge/Steam-000000?style=for-the-badge&logo=steam&logoColor=white
[Discord Badge]: https://img.shields.io/badge/Discord-7289DA?style=for-the-badge&logo=discord&logoColor=white

[Discord]: https://discord.gg/lucidvr
[Steam]: https://store.steampowered.com/app/1574050/OpenGloves

[Installation]: docs/Installation.md
[Limitations]: docs/Limitations.md
[Compatibility]: docs/Compatibility.md

[UI]: https://github.com/lucidVR/opengloves-ui
[Open Interface]: https://github.com/LucidVR/opengloves-driver/wiki/Driver-Input

[Issue]: https://github.com/LucidVR/opengloves-driver/issues

[Danwillm]: https://github.com/danwillm
[Lucas VRTech]: https://github.com/lucas-vrtech
